/*
 * Copyright 2005 Red Hat, Inc.
 * Copyright 2005 Peter M. Jones (pjones@redhat.com)
 *
 * vim:ts=8:sw=8:sts=8:noet
 */
#ifndef PYBLOCK_DMRAID_H
#define PYBLOCK_DMRAID_H 1

typedef struct {
	PyObject_HEAD

	struct lib_context *lc;
	PyObject *children;
} PydmraidContextObject;
PyAPI_DATA(PyTypeObject) PydmraidContext_Type;

#define PydmraidContext_Check(op) PyObject_TypeCheck(op, &PydmraidContext_Type)
#define PydmraidContext_CheckExact(op) ((op)->ob_type == &PydmraidContext_Type)

typedef struct {
	PyObject_HEAD

	PydmraidContextObject *ctx;
	PyObject *idx;

	char *path;
	char *serial;
	u_int64_t sectors;
} PydmraidDeviceObject;
PyAPI_DATA(PyTypeObject) PydmraidDevice_Type;

#define PydmraidDevice_Check(op) PyObject_TypeCheck(op, &PydmraidDevice_Type)
#define PydmraidDevice_CheckExact(op) ((op)->ob_type == &PydmraidDevice_Type)

typedef struct {
	PyObject_HEAD

	PydmraidContextObject *ctx;
	PyObject *idx;

	struct raid_dev *rd;
} PydmraidRaidDevObject;
PyAPI_DATA(PyTypeObject) PydmraidRaidDev_Type;

#define PydmraidRaidDev_Check(op) PyObject_TypeCheck(op, &PydmraidRaidDev_Type)
#define PydmraidRaidDev_CheckExact(op) ((op)->ob_type == &PydmraidRaidDev_Type)

typedef struct {
	PyObject_HEAD

	PydmraidContextObject *ctx;
	PyObject *idx;

	struct raid_set *rs;
} PydmraidRaidSetObject;
PyAPI_DATA(PyTypeObject) PydmraidRaidSet_Type;

#define PydmraidRaidSet_Check(op) PyObject_TypeCheck(op, &PydmraidRaidSet_Type)
#define PydmraidRaidSet_CheckExact(op) ((op)->ob_type == &PydmraidRaidSet_Type)

extern PyObject *PydmraidRaidSet_FromContextAndRaidSet(
		PydmraidContextObject *ctx, struct raid_set *rs);

typedef struct {
	PyObject_HEAD

	PydmraidContextObject *ctx;
	PyObject *idx;

	enum lc_lists type;
} PydmraidListObject;
PyAPI_DATA(PyTypeObject) PydmraidList_Type;

#define PydmraidList_Check(op) PyObject_TypeCheck(op, &PydmraidList_Type)
#define PydmraidList_CheckExact(op) ((op)->ob_type == &PydmraidList_Type)

extern PyObject *PydmraidList_FromContextAndType(PydmraidContextObject *ctx,
		enum lc_lists type);

extern PyObject *GroupingError;
#endif /* PYBLOCK_DMRAID_H */
